#include "http_client.h"

void result_callback(void *arg, httpc_result_t httpc_result, u32_t rx_content_len, u32_t srv_res,
                     err_t err) {
    printf("Transfer complete\n");
    printf("Local result=%d\n", httpc_result);
    printf("Http result=%d\n", srv_res);
}

err_t headers_callback(httpc_state_t *connection, void *arg, struct pbuf *hdr, u16_t hdr_len,
                       u32_t content_len) {
    printf("Headers received\n");
    printf("Content length=%d\n", content_len);
    printf("Header length=%d\n", hdr_len);

    pbuf_copy_partial(hdr, myBuffer, hdr->tot_len, 0);
    printf("Headers \n");
    printf("%s", myBuffer);

    return ERR_OK;
}

err_t body_callback(void *arg, struct altcp_pcb *conn, struct pbuf *p, err_t err) {
    bool *test = (bool *)arg;
    printf("...");
    pbuf_copy_partial(p, myBuffer, p->tot_len, 0);
    // printf("%s", myBuffer);

    // TODO: Parse CSV
    *test = true;

    return ERR_OK;
}

HttpClient::HttpClient() {
    m_settings.use_proxy = false;
    m_settings.result_fn = nullptr;       // result_callback;
    m_settings.headers_done_fn = nullptr; // headers_callback;
}

std::string HttpClient::retrieveWasteDatesAsCsv() {
    uint16_t port = 80;

    std::string test("");

    err_t err = httpc_get_file_dns("beenas.brodbeck-online.de", port, "/abfall/abfall.csv",
                                   &m_settings, body_callback, &m_received, nullptr);
    // printf("Status %d\n", err);

    printf("Waiting for waste dates ");

    while (m_received == false) {
        sleep_ms(100);
    }

    printf(" received.\n");

    test.append(myBuffer);

    return test;
}