#pragma once

#include "pico/stdlib.h"

#include "ws2812.pio.h"

enum class Color : uint32_t {
    RED = 0xff0000,
    GREEN = 0x00ff00,
    BLUE = 0x0000ff,
    WHITE = 0xffffff,
    OFF = 0x000000,
    YELLOW = 0xffff00
};

class WS2812 {
  public:
    WS2812(uint gpio, PIO pio = pio0, uint sm = 0);
    void switchColor(Color color);

  private:
    void putPixel(uint32_t pixel_rgb);
    PIO m_pio;
    uint m_sm;
};

static inline void put_pixel(uint32_t pixel_grb) { pio_sm_put_blocking(pio0, 0, pixel_grb << 8u); }

// static inline uint32_t urgb_u32(uint8_t r, uint8_t g, uint8_t b) {
//     return ((uint32_t)(r) << 8) | ((uint32_t)(g) << 16) | (uint32_t)(b);
// }